//+------------------------------------------------------------------+
//|                                              #MTF_HULL_TREND.mq4 |
//|------------------------------------------------------------------+

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LightSkyBlue
#property  indicator_color2  OrangeRed

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------*/

extern int    TimeFrame = 15;
// Ergo Variables

extern int pq =8;//was 4
extern int pr = 8;//was 10
extern int ps = 5;//was 5
extern int trigger =4;//was 3

//---- indicator buffers

string signal;
double mtm[];
double absmtm[];
double ErgoCCI[];
double MainCCI[];
double var1[];
double var2[];
double var2a[];
double var2b[];
double alertTag;
//double valor1[];
//double valor2[];
//double extvar[];
string previous;
double alertBar;
extern bool SoundAlert = true;
double prev;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   
//---- indicator line
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,Blue);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Red);
   
   SetIndexBuffer(0,ErgoCCI);
   SetIndexLabel(0,"Egodic CCI");
   SetIndexBuffer(1,MainCCI);
   SetIndexLabel(1,"Trigger Line");
   SetIndexBuffer(2,mtm);
   SetIndexBuffer(3,var1);
   SetIndexBuffer(4,var2);
   SetIndexBuffer(5,absmtm);
   SetIndexBuffer(6,var2a);
   SetIndexBuffer(7,var2b);
//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("#MTF_FX_Ergodic("+TimeFrameStr+")");

  }

//----

   return(0);
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-1;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  

   ErgoCCI[i]=iCustom(Symbol(),TimeFrame,"FX_Sniper's_Ergodic_CCI_Trigger",0,y);
   MainCCI[i]=iCustom(Symbol(),TimeFrame,"FX_Sniper's_Ergodic_CCI_Trigger",1,y); 
   if(prev == 0) prev = ErgoCCI[i]; 
   if(prev < ErgoCCI[i] && ErgoCCI[i] == MainCCI[i] && ErgoCCI[i] != EMPTY_VALUE && MainCCI[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MTF FX_Ergodic Alert Up "," up= " + Symbol() + " on the " +  Period() + " minute chart.");alertBar = Bars;prev = ErgoCCI[i];}
   if(prev > ErgoCCI[i] && ErgoCCI[i] == MainCCI[i] && ErgoCCI[i] != EMPTY_VALUE && MainCCI[i] != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("#MMTF FX_Ergodic Alert Down "," up= " + Symbol() + " on the " + Period() + " minute chart.");alertBar = Bars;prev = ErgoCCI[i];}
   }
   return(0);
  }
//+------------------------------------------------------------------+